// CeoBroj.java - Klasa celih brojeva.

package aritmetika;

public class CeoBroj implements Numericko {
  private int i;                                     // Vrednost broja.

  public CeoBroj(int ii) { i = ii; }                 // Inicijalizacija.

  public CeoBroj clone() {                           // Kopija broja.
    try { return (CeoBroj)super.clone(); }
      catch (CloneNotSupportedException g) { return null; }
  }

  public CeoBroj dodaj(Numericko b) throws GNumTip { // Dodavanje broja.
    if (!(b instanceof CeoBroj)) throw new GNumTip();
    i += ((CeoBroj)b).i;
    return this;
  }
                                                     // Proizvod dva broja.
  public Numericko proizvod(Numericko b) throws GNumTip {
    if (!(b instanceof CeoBroj)) throw new GNumTip();
    return new CeoBroj(i * ((CeoBroj)b).i);
  }

  public String toString()                           // Tekstualni opis.
    { return Integer.toString(i); }
}
