// Grafika.java - Klasa za crtanje krivih.

package grafika;

import java.awt.*;
import java.awt.event.*;

public class Grafika extends Frame {
  
  private Kriva kriva = new Spirala (); // Kriva koja se crta.
  private volatile Thread nit = null;   // Nit koja crta.
  private TextField                     // Polja za tekst za unos
    tksPmax = new TextField( "10", 4),  //   parametara.
    tksDp   = new TextField( ".1", 4),
    tksDt   = new TextField("100", 4),
    tksA    = new TextField(  "1", 4),
    tksN    = new TextField(  "6", 4);
  private Checkbox rdgSpirala, rdgCvet; // Radio dugmad za izbor krive.
  
  private class Platno extends Canvas   // PLATNO PO KOME SE CRTA.
                       implements Runnable {
    
    public void paint(Graphics g) {     // Poetak crtanja.
      if (nit != null) nit.interrupt();
      (nit = new Thread(this)).start();
    }

    public void run() {                 // Telo niti koja crta.
      if (rdgSpirala.getState()) {
        kriva = new Spirala(Double.parseDouble(tksA.getText()));
      } else if (rdgCvet.getState()) {
        kriva = new Cvet(
          Double .parseDouble(tksA.getText()),
          Integer.parseInt   (tksN.getText())
        );
      }
      double pmax= Double.parseDouble(tksPmax.getText()),
             dp  = Double.parseDouble(tksDp  .getText());
      int    dt  = Integer.parseInt  (tksDt  .getText());
      int    sir = getWidth(), vis = getHeight ();
      Graphics g = getGraphics();
      g.setColor (Color.BLACK);
      try {
        Tacka t = kriva.t(0);
        int x0  = (int)((t.x() + 10) / 20 * sir),
            y0  = (int)((10 - t.y()) / 20 * vis);
        for (double p=dp; p<=pmax && !Thread.interrupted(); p+=dp) {
          t = kriva.t(p);
          int x = (int)((t.x() + 10) / 20 * sir),
              y = (int)((10 - t.y()) / 20 * vis);
          g.drawLine (x0, y0, x, y);
          x0 = x; y0 = y;
          Thread.sleep(dt);
        }
      } catch (InterruptedException gr) {}
      //nit = null;
    }
  } // class Platno
  
  private Platno platno = new Platno();     // Platno po kojoj se crta.
  
  private Grafika() {                       // Inicijalizacija.
    super ("Grafika");
    setBounds(100, 100, 400,300);
    popuniProzor();
    setVisible(true);
    addWindowListener (new WindowAdapter() {
      public void windowClosing(WindowEvent d) {
        if (nit != null) nit.interrupt();
        dispose();
      }
    });
  }
  
  private void popuniProzor() {             // Popunjavanje prozora:
    add(platno, "Center");
    platno.setBackground(new Color(240,240,240));
    Panel ploca = new Panel(new GridLayout (0,1));
    add (ploca, "South");
    Panel plo = new Panel();                // - ploa za parametre crtanja,
    ploca.add (plo);
    plo.add(new Label("pmax:", Label.RIGHT));
    plo.add(tksPmax);
    plo.add(new Label("dp:",   Label.RIGHT));
    plo.add(tksDp);
    plo.add(new Label("dt:",   Label.RIGHT));
    plo.add(tksDt);

    ploca.add(plo = new Panel());           // - ploa za parametre krivih,
    CheckboxGroup grp = new CheckboxGroup();
    plo.add(rdgSpirala = new Checkbox("Spirala", grp, true));
    plo.add(rdgCvet    = new Checkbox("Cvet", grp, false));
    plo.add(new Label("a:", Label.RIGHT));
    plo.add(tksA);
    plo.add(new Label("n:", Label.RIGHT));
    plo.add(tksN);
    
    ploca.add(plo = new Panel());           // - ploa za komandnu dugmad.
    Button dgm = new Button("Crtaj");
    plo.add(dgm);
    dgm.addActionListener(new ActionListener () {
      public void actionPerformed(ActionEvent d)
        { platno.repaint();       }
    });
    plo.add(dgm = new Button("Prekini"));
    dgm.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent d) {
        if (nit != null) { nit.interrupt(); nit = null; }
      }
    });
  } // popuniProzor()
  
  public static void main(String[] varg)    // GLAVNA FUNKCIJA.
    { new Grafika(); }
}
