// Tocak.java - Klasa tokova maine za izvlaenje.

package lutrija1;

class Tocak extends Thread implements Generator {
  private int cifra;                   // Trenutna cifra.
  private int dt;                      // Vreme izmeu dve promene.
  private int korak;                   // Korak promene (smer).
  private boolean radi = false;        // Da li se vrti?

  Tocak(int ddt, boolean raste) {      // Inicijalizacija.
    dt = ddt;
    korak = raste ? 1 : -1;
    start();
  }

  public void run() {                  // Telo niti.
    try {
      while (!interrupted()) {
        synchronized (this) { if (!radi) wait(); }
        sleep (dt);
        cifra = (cifra + korak + 10) % 10;
      }
    } catch (InterruptedException g) {}
  }

  synchronized void kreni() {          // Pokretanje toka.
    radi = true; notify();
  }

  public int slBroj() {                // Zaustavljanje i oitavanje.
    radi = false;
    return cifra;
  }

  void zavrsi() { interrupt(); }       // Zavretak niti.
}