// Tocak.java - Klasa tokova.

package lutrija2;
import java.awt.*;

class Tocak extends Label implements Runnable {
  private int cifra;                      // Trenutna cifra.
  private int korak;                      // Korak promene cifre.
  private int dt;                         // Vreme izmeu dve promene.
  private Thread nit = new Thread (this); // Nit toka.
  private boolean radi = false;           // Da li se vrti?

  Tocak(int ddt, boolean raste) {         // Inicijalizacija.
    dt = ddt;
    korak = raste ? 1 : -1;
    setFont(new Font(null, Font.BOLD, 24));
    setBackground(Color.YELLOW);
    setForeground(Color.RED);
    setAlignment(CENTER);
    brisi();
    nit.start();
  }

  public void run() {                     // Telo niti.
    try {
      while (!Thread.interrupted()) {
        synchronized (this) { if (!radi) wait(); }
        cifra = (cifra + korak + 10) % 10;
        setText(Integer.toString(cifra));
        Thread.sleep(dt);
      }
    } catch (InterruptedException g) {}
  }

  public void brisi() { setText("  "); }  // Pranjenje natpisa. 

  synchronized void kreni()               // Pokretanje toka.
    { radi = true; notify(); }

  public int cifra ()                     // Zaustavljanje toka.
    { radi = false; return cifra; }

  void zavrsi() { nit.interrupt(); }      // Prekidanje niti.
}
