// PromVel - Apstraktna klasa promenljivih fizikih veliina.

package merenje;

public abstract class PromVel extends Thread implements Vel {
  private long tmin, tmax;                // Granina vremena promena.
  private volatile double vr, min, max;   // Trenutna i granine vrednosti.
  double delta;

  public PromVel(long mint, long maxt,    // Inicijalizacija.
                 double vr0, double del, double minVr, double maxVr) {
    tmin = mint; tmax = maxt;
    vr = vr0; delta = del; min = minVr; max = maxVr;
    start();
  }
                                          // Trenutna vrednost veliine.
  public synchronized double vrednost() { return vr; }

  public void run() {                     // Telo niti.
    try {
      while (!interrupted()) {
        long t = tmin + (int)(Math.random()*(tmax-tmin));
        sleep(t);
        synchronized (this) {
          vr += (Math.random()*2 - 1) * delta;
          if (vr < min) vr = min;
          if (vr > max) vr = max; 
        }
      }
    } catch (InterruptedException g) {}
  }

  public void prekini() { interrupt(); }  // Zavretak niti.
}
