// Ulaz.java - Klasa ulaza parkinga.

package parkiranje;

public class Ulaz extends Thread {
  private Parking park;             // Matini parkiranje.
  private int minUl, maxUl;         // Opseg vremena izmeu dva ulaska.
  private int minPark, maxPark;     // Opseg trajanja parkiranja. 
  private boolean otvoren = false;  // Da li je otvoren?
  private String[] marke = {"BMW"}; // Mogue marke.
  
  public Ulaz (Parking p, int minU, int maxU, int minP, int maxP) {
    park = p; minUl = minU; maxUl = maxU;       // Inicijalizacija.
    minPark = minP; maxPark = maxP;
    start();
  }
  
  public void postavi(String[] marke)           // Postavljanje niza marki.
    { this.marke = marke; }
  
  public void run() {                           // Telo niti.
    try {
      while (!interrupted()) {
        synchronized(this) { while (!otvoren) wait(); }
        sleep((long)(minUl + Math.random()*(maxUl-minUl)));
        int k = (int)(Math.random() * marke.length);
        new Automobil(marke[k], park, minPark, maxPark);
      }
    } catch (InterruptedException g) {}
  }
  
  public synchronized void otvori()             // Otvaranje ulaza.
    { otvoren = true; notify(); }
  
  public synchronized void zatvori()            // Zatvaranje ulaza.
    { otvoren = false; }
  
  public void unisti() { interrupt(); }         // Prekidanje niti.
}
