// Stoperica.java - Klasa toperice.

package slagalica;
import java.awt.*;

public class Stoperica extends Thread {
  private Label prik;                           // Prikaziva toperice.
  private boolean radi = false;                 // Da li radi?
  private long t0;                              // Poetak merenja.
    
  public Stoperica(Label p)                     // Inicijalizacija.
    { prik = p; start(); }
  
  public void run() {                           // Telo niti.
    try {
      while( !interrupted()) {
        synchronized (this) { if (!radi) wait(); }
        prik.setText(toString());
        sleep(100);
      }
    } catch (InterruptedException g) {}
  }
  
  public synchronized void kreni() {            // Pokretanje.
    t0 = System.currentTimeMillis();
    radi = true; notify();
  }
  
  public void stani() { radi = false; }         // Zaustavljanje.
  
  public void zavrsi() { interrupt(); }         // Prekidanje niti.

  public String toString() {                    // Tekstualni opis.
    long dt = (System.currentTimeMillis() - t0) / 100;
    return String.format("%2d:%4.1f", dt/600, dt%600/10.);
  }
}
