// Tabla.java - Klasa tabli.

package slagalica;
import java.awt.*;
import java.awt.event.*;

public class Tabla extends Panel {
  Button[] dugmad = new Button [16];            // Dugmad na tabli.
  private Button prazno;                        // Prazno dugme.
  private Stoperica stoperica;                  // Koriena toperica.
  
  public Tabla(Stoperica stopr) {               // Inicijalizacija.
    stoperica = stopr; 
    setLayout(new GridLayout(4, 4));
    setEnabled(false);
    DugmeAkcija osl = new DugmeAkcija();
    for (int i=0; i<16; i++) {
      add(dugmad[i] = new Button());
      dugmad[i].addActionListener(osl);
    }
  } 

  void postavi() {                              // Postavljanje table.
    stoperica.stani();
    for (Button d: dugmad) d.setLabel(""); 
    for (int i=1; i<16; i++) {
      int k = 0;
      while (!dugmad[k = (int)(Math.random()*16)].getLabel().equals(""));
      dugmad[k].setLabel(Integer.toString(i));
    }
    int i = 0; while (!dugmad[i].getLabel().equals("")) i++;
    prazno = dugmad[i];
    setEnabled(true);
    stoperica.kreni();
  }

  private class DugmeAkcija implements ActionListener { // Oslukiva
    public void actionPerformed(ActionEvent d) {        // komandnog
      Button dgm = ((Button)d.getSource());             // dugmeta.
      if (dgm != prazno) {  // Premetanje natpisa na prazno dugme.
        prazno.setLabel(dgm.getLabel());
        dgm.setLabel("");
        prazno = dgm;
      }
      int i=0;              // Da li su natpisi ureeni do kraja?
      while (i<15) {
        if (dugmad[i]==prazno ||
            Integer.parseInt(dugmad[i].getLabel()) != i+1) break;
        i++;
      }
      if (i == 15) { setEnabled(false); stoperica.stani(); }
    }
  }
}
