// Grupa.java - Klasa grupe elektrinih potroaa.

package struja;

public class Grupa extends Potrosac {
  private static class Elem {                   // Element liste:
    Potrosac potr;                              // - sadrani potroa,
    Elem sled;                                  // - sledei element,
    Elem(Potrosac p) { potr = p; }              // - inicijalizacija.
  }

  private Elem prvi, posl;                      // Poetak i kraj liste.
  double snaga;                                 // Snaga grupe potroaa.
  
  public Grupa dodaj(Potrosac p) {              // Dodavanje potroaa.
    Elem novi = new Elem(p);
    if (prvi == null) prvi = novi; else  posl.sled = novi;
    posl = novi;
    snaga += p.snaga();
    return this;
  }
  
  public double snaga() { return snaga; }       // Snaga grupe potroaa.
  
  public String toString() {                    // Tekstualni opis.
    String s = "[";
    for (Elem tek=prvi; tek!=null; tek=tek.sled) {
      s += tek.potr;
      if (tek.sled != null) s += ",";
    }
    return s + "]";
  }
}
