// Izvor.java - Klasa izvora elektrine energije.

package struja;

public class Izvor {
  private Potrosac[] niz;                       // Prikljuna mesta.
  private double snaga, opter;                  // Snaga i optereenje
                                                //   izvora.
  public Izvor(double s, int k) {               // Inicijalizacija.
    niz = new Potrosac [k];
    snaga = s;
  }
  
  public double snaga() { return snaga; }       // Snaga izvora.
  
  public double opterecenje() { return opter; } // Optereenje izvora.
  
  public int brMesta () { return niz.length; }  // Broj mesta.
  
  public boolean prikljuci(Potrosac p, int i) { // Prikljuivanje
    if (i<0 || i>niz.length-1) return false;    //   potroaa.
    if (niz[i] != null) {
      opter -= niz[i].snaga();
      niz[i] = null;
    }
    if (p == null) return true;
    double s = p.snaga();
    if (opter+s > snaga) return false;
    niz[i] = p; opter += s;
    return true;
  }
 
  public String toString() {                    // Tekstualni opis.
    String s = opter + "/" + snaga + "\n";
    for (int i=0; i<niz.length; i++)
      s += i + ": " + (niz[i]!=null ? niz[i] : "<< prazno >>") + "\n";
    return s;
  }
}
