// Vagon.java - Klasa vagona.

package vozovi;

public class Vagon extends Vozilo {

  private Niz<Teret> tereti;                    // Niz tereta.

  public Vagon(double st, int k)                // Inicijalizacija.
    { super(st); tereti = new Niz<Teret>(k); }
  public Vagon dodaj(Teret t) throws GPun       // Dodavanje tereta.
    { tereti.dodaj(t); return this; }
  
  public double ukTezina() {                    // Ukupna teina.
    double t = super.ukTezina();
    try {
      for (int i=0; i<tereti.duzina(); i++)
        t += tereti.dohvati(i).tezina();
    } catch (GIndeks g) {}
    return t;
  }

  public double vucnaSnaga() { return 0; }      // Vuna snaga.

  public String toString() {                    // Tekstualni opis.
    StringBuilder s = new StringBuilder();
    s.append("V(").append(ukTezina()).append("|");
    try {
      for (int i=0; i<tereti.duzina(); i++) {
        if (i > 0) s.append(",");
        s.append(tereti.dohvati(i));
      }
    } catch (GIndeks g) {}
    return s.append(")").toString();
  }
}

